;*** General note from the developers :                                       ***
;***                                                                          ***
;*** IMPORTANT INFO ABOUT GETTING STARTED: Lines that start with a            ***
;*** semicolon, such as this one, are comments.  They are not executed.       ***
;***                                                                          ***
;*** This script has a special filename and path because it is automatically  ***
;*** launched when you run the program directly.  Also, any text file whose   ***
;*** name ends in .ahk is associated with the program, which means that it    ***
;*** can be launched simply by double-clicking it.  You can have as many .ahk ***
;*** files as you want, located in any folder.  You can also run more than    ***
;*** one ahk file simultaneously and each will get its own tray icon.         ***


;*** Version June 18, 2009 ***

; ____________________General Area. ______________________
;
;*** This part is executed at "Reload Script" only. Ends at the first unconditional Return. ***
;*** All which is executed here counts for each Hot Key call.                               ***


SetTitleMatchMode 2                                                            ;Denotes "Is contained" in the Title.

;*** Get the current install location of XXHighEnd from the Environment Variable XXStartUpDir.            ***
;*** Note XXStartUpDit is actual only when AutoHotkey is restarted once after XXHighEnd has been launched ***
;*** a first time for its current version.                                                                ***
;*** IF you swap between XXHighEnd versions, you must reload the XX.ahk as well to read the XX location.  ***
;*** (rightclick on the "H" icon in the taskbar tray, "Reload This Script").                              ***

EnvGet, StartUpDir, XXStartUpDir
msgbox ,48,,% StartUpDir . " <<== should show your current XX folder." . chr(13) . "If not, Hot Keys work out wrongly !!"


return                                                        ;End of General Area.

; ________________ End of General Area. __________________


; ________________ Definition of Hot Keys. ________________

;*** Note that the below Hot Key definitions and all the checking upon XXHighEnd already running or not,         ***
;*** is about having the same Hot Keys for when XXHighEnd runs and when it not runs.                             ***
;*** Note that once AutoHotkey is running, any same definitions (like Alt-p (!P::) for Play) will override       ***
;*** the internal definitions. So, the internal definitions just will not be active then.                        ***
;*** The internal Hot Keys are always Alt- versions, and the "external" Hot Keys *could* be different.           ***
;*** Since this latter will not be convenient *and* because the external definitions (once they exist) will      ***
;*** override the internal ones, the external definitions should perform just different actions. This means      ***
;*** - when XXHighEnd is running the clicks on buttons etc. are performed as if you did it with the mouse;       ***
;*** - when XXHighEnd not is running, it is started and it performs the action by means of the passed parameter. ***
;*** Example of the latter for Play : run, %StartUpDir%\xxhighend p, %StartUpDir%                                ***
;*** where the parameter p internally in XXHighEnd is redirected to perform Playback.                            ***
;*** In the end this is all about being compatible with XXHighEnd running with - and without AutoHotkey.         ***



;*** Start XXHighEnd. Is allowed more than once. ***


!x::    ;Start XX.
  run, %StartUpDir%\xxhighend, %StartUpDir%
  return



;*** Off (Quit). ***

!o::
IfWinExist, XXHighEnd, ,Studio                                                  ;XXHighEnd already runs ? If yes, click on the button (ControlClick).
{
   ControlClick, &Off, XXHighEnd,, Left, , ,Studio                              ;Studio is for the Development Environment, which also is called XXHighEnd.
   return
}
  else
{
; run, %StartUpDir%\xxhighend o, %StartUpDir%                                   ;Do nothing, hence do not start for Quitting.
  return
}



;*** Play. ***

!p::
IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, &Play, XXHighEnd,, Left, , ,Studio
   return
}
  else
{
  run, %StartUpDir%\xxhighend p, %StartUpDir%                                   ;Can only work in combination with Unattended !!
  return
}


;*** Stop. ***

!s::    ;Stop.

IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, &Stop, XXHighEnd,, Left, , ,Studio
   return
}
  else
{
  run, %StartUpDir%\xxhighend s, %StartUpDir%
  return
}



;*** Pause. ***

!e::    ;Pause.

IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, Paus&e, XXHighEnd,, Left, , ,Studio                            ;Note the &e denotes the internal hotkey (Alt-e).
   return
}
  else
{

  run, %StartUpDir%\xxhighend e, %StartUpDir%
  return
}


;*** Nt. ***

!n::    ;Next Track.

IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, &Nt, XXHighEnd,, Left, , ,Studio                              ;05-04-2009,PS, Was Next.
   return
}
  else
{

  run, %StartUpDir%\xxhighend n, %StartUpDir%
  return
}


;*** Nal. ***                                                                  ;05-04-2009,PS.

!l::    ;Next Album.

IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, Na&l, XXHighEnd,, Left, , ,Studio
   return
}
  else
{

  run, %StartUpDir%\xxhighend l, %StartUpDir%
  return
}


;*** Previous. Not allowed for Unattended. ***

!v::    ;Previous.                                                            ;18-06-2009,PS, Was r.
  ControlClick, Pre&vious, XXHighEnd,, Left, , ,Studio
  return


;*** Set A, B and Nothing point from A-B Playback. Note that all occurs by subsequent clicks, the third setting back to nothing. ***
;*** When error messages occur (like setting A and B at the same point) you're kind of lost at Unattended.                       ***

!a::    ;Set A-B-Nothing point.
IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, &A-B, XXHighEnd,, Left, , ,Studio
   return
}
  else
{

  run, %StartUpDir%\xxhighend a, %StartUpDir%
  return
}


;*** Set B point from A-B playback. ***
;
;!b::    ;Set B point.
;IfWinExist, XXHighEnd, ,Studio
;{
;   ControlClick, &A-B, XXHighEnd,, Left, , ,Studio
;   return
;}
;  else
;{
;  run, %StartUpDir%\xxhighend b, %StartUpDir%
;  return
;}

;*** Notch Volume Up. ***

!u::    ;Volume Up.
IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, Notch&UpVolume, XXHighEnd,, Left, , ,Studio              ;But note this uses the NOT legit steps when available !!
   return
}
  else
{
  run, %StartUpDir%\xxhighend u, %StartUpDir%
  return
}


;*** Notch Volume Down. ***

!d::    ;Volume Down.
IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, Notch&DownVolume, XXHighEnd,, Left, , ,Studio            ;But note this uses the NOT legit steps when available !!
   return
}
  else
{

  run, %StartUpDir%\xxhighend d, %StartUpDir%
; msgbox % "Down2"
; run, %StartUpDir%\xxhighend p, %StartUpDir%
  return
}


;*** Switch Attended/Unattended. ***

!t::    ;Unattended/Attended.
  IfWinExist, XXHighEnd, ,Studio
  {
    ControlSend, Una&ttended, {Space}, XXHighEnd,, Studio                 ;Space is a means to change the state of a  checkbox just the same.
    return
  }
    else
  {
    run, %StartUpDir%\xxhighend t, %StartUpDir%
    return
  }


;*** Switch End After Track. ***

!k::    ;Unattended/Attended.
  IfWinExist, XXHighEnd, ,Studio
  {
    ControlSend, End after trac&k, {Space}, XXHighEnd,, Studio
    return
  }
    else
  {
    run, %StartUpDir%\xxhighend k, %StartUpDir%                           ;But note that when Unattended this effictively can switch On only.
    return                                                                ;Once set On, going back to "play on" is not possible.
  }



;*** Double. ***

!b::    ;Double.
IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, Dou&ble, XXHighEnd,, Left, , ,Studio
   return
}
  else
{

  run, %StartUpDir%\xxhighend b, %StartUpDir%
  return
}


;*** Quad. ***

!q::    ;Quad.
IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, &Quad, XXHighEnd,, Left, , ,Studio
   return
}
  else
{

  run, %StartUpDir%\xxhighend q, %StartUpDir%
  return
}


;*** Upsample. ***

!m::    ;Upsample.
IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, UpS&mp, XXHighEnd,, Left, , ,Studio
   return
}
  else
{

  run, %StartUpDir%\xxhighend m, %StartUpDir%
  return
}



;*** Invert. ***

!i::    ;Invert.                                                          ;18-06-2009,PS, Was v.        
IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, &Invert, XXHighEnd,, Left, , ,Studio
   return
}
  else
{

  run, %StartUpDir%\xxhighend i, %StartUpDir%
  return
}


;*** 18-06-2009,PS, Remote Control for Show/Hide Icons has been discontinued !
;*** Show/Hide Icons. ***

;!i::    ;Show/Hide Icons.
;IfWinExist, XXHighEnd, ,Studio
;{
;   ControlClick, &I, XXHighEnd,, Left, , ,Studio
;   return
;}
;  else
;{
;
;  run, %StartUpDir%\xxhighend I, %StartUpDir%
;  return
;}


;*** 23-03-2009,PS, Show/Hide Running Time (Unattended only). ***

!g::    ;Show/Hide Running Time.
IfWinExist, XXHighEnd, ,Studio
{
   ControlClick, &G, XXHighEnd,, Left, , ,Studio               ;Works only with the Setting Tab as the active tab !
   return
}
  else
{

  run, %StartUpDir%\xxhighend G, %StartUpDir%                  ;Works only when the Running Time OSD checkbox is ticked and does not untick/tick the checkbox itself !
  return
}


;*** 06-04-2009,PS, Load Library Item (Unattended only). ***

!f::    ;Load Library Item.
IfWinExist, XXHighEnd, ,Studio
{
   ;ControlClick, &--, XXHighEnd,, Left, , ,Studio             ;Not active.
   ;return
}
  else
{

  run, %StartUpDir%\xxhighend F, %StartUpDir%
  return
}


;*** 12-11-2009,PS, Add Track to the Demo Gallery Folder (see Settings Area). Unattended only. ***

!z::    ;Copy Track to Demo.
{
  run, %StartUpDir%\xxhighend Z, %StartUpDir%
  return
}


;*** 04-10-2009,PS, Add Track to the NiceStuff Gallery Folder (see Settings Area). Unattended only. ***

!c::    ;Copy Track to Nice Stuff.
{
  run, %StartUpDir%\xxhighend C, %StartUpDir%
  return
}


;*** 04-10-2009,PS, Add Album from the currently playing track to the NiceStuff Gallery Folder (see Settings Area). Unattended only. ***

!h::    ;Copy Album to Nice Stuff.
{
  run, %StartUpDir%\xxhighend H, %StartUpDir%
  return
}

return


IsRunning()

{
  ; When XXHighEnd is already running, stop the script.
  ; Just call this function when a second startup of XXHighEnd is not allowed.
  ; In the standard setup this is not used.


  IfWinExist, XXHighEnd, ,Studio  ;Allow for internal hotkeys (alt-).
    exit      ;Stop the script !
  return                                                                          ;Does not run. Continue the script.
}